Index: pacemaker/pengine/test10/bug-1820-1.exp
===================================================================
--- pacemaker.orig/pengine/test10/bug-1820-1.exp
+++ pacemaker/pengine/test10/bug-1820-1.exp
@@ -3,7 +3,7 @@
      <action_set>
       <rsc_op id="6" operation="start" operation_key="p1_start_0" on_node="world" on_node_uuid="e4603bf6-d10f-4af2-b53b-ba72de6164d0">
         <primitive id="p1" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="world" CRM_meta_on_node_uuid="e4603bf6-d10f-4af2-b53b-ba72de6164d0" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
     <inputs>
@@ -19,7 +19,7 @@
     <action_set>
       <rsc_op id="5" operation="monitor" operation_key="p1_monitor_0" on_node="world" on_node_uuid="e4603bf6-d10f-4af2-b53b-ba72de6164d0">
         <primitive id="p1" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="world" CRM_meta_on_node_uuid="e4603bf6-d10f-4af2-b53b-ba72de6164d0" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -28,7 +28,7 @@
      <action_set>
       <rsc_op id="4" operation="monitor" operation_key="p1_monitor_0" on_node="star" on_node_uuid="3f368213-61d5-409a-a30e-1428efe70f63">
         <primitive id="p1" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="star" CRM_meta_on_node_uuid="3f368213-61d5-409a-a30e-1428efe70f63" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
     <inputs/>
@@ -93,7 +93,7 @@
      <action_set>
       <rsc_op id="11" operation="migrate_from" operation_key="test1_migrate_from_0" on_node="world" on_node_uuid="e4603bf6-d10f-4af2-b53b-ba72de6164d0">
         <primitive id="test1" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_migrate_source="star" CRM_meta_migrate_target="world" CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test1"/>
+        <attributes CRM_meta_migrate_source="star" CRM_meta_migrate_target="world" CRM_meta_on_node="world" CRM_meta_on_node_uuid="e4603bf6-d10f-4af2-b53b-ba72de6164d0" CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test1"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -106,7 +106,7 @@
      <action_set>
       <rsc_op id="10" operation="migrate_to" operation_key="test1_migrate_to_0" on_node="star" on_node_uuid="3f368213-61d5-409a-a30e-1428efe70f63">
         <primitive id="test1" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_migrate_source="star" CRM_meta_migrate_target="world" CRM_meta_name="migrate_to" CRM_meta_record_pending="true" CRM_meta_timeout="120000" allow_migrate="true"  xmfile="/etc/xen/test1"/>
+        <attributes CRM_meta_migrate_source="star" CRM_meta_migrate_target="world" CRM_meta_name="migrate_to" CRM_meta_on_node="star" CRM_meta_on_node_uuid="3f368213-61d5-409a-a30e-1428efe70f63" CRM_meta_record_pending="true" CRM_meta_timeout="120000" allow_migrate="true"  xmfile="/etc/xen/test1"/>
       </rsc_op>
     </action_set>
     <inputs/>
@@ -115,7 +115,7 @@
     <action_set>
       <rsc_op id="9" operation="monitor" operation_key="test1_monitor_10000" on_node="world" on_node_uuid="e4603bf6-d10f-4af2-b53b-ba72de6164d0">
         <primitive id="test1" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_start_delay="30000" CRM_meta_timeout="30000" allow_migrate="true"  xmfile="/etc/xen/test1"/>
+        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_on_node="world" CRM_meta_on_node_uuid="e4603bf6-d10f-4af2-b53b-ba72de6164d0" CRM_meta_start_delay="30000" CRM_meta_timeout="30000" allow_migrate="true"  xmfile="/etc/xen/test1"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -146,7 +146,7 @@
      <action_set>
       <rsc_op id="7" operation="stop" operation_key="test1_stop_0" on_node="star" on_node_uuid="3f368213-61d5-409a-a30e-1428efe70f63">
         <primitive id="test1" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_name="stop" CRM_meta_timeout="120000" allow_migrate="true"  xmfile="/etc/xen/test1"/>
+        <attributes CRM_meta_name="stop" CRM_meta_on_node="star" CRM_meta_on_node_uuid="3f368213-61d5-409a-a30e-1428efe70f63" CRM_meta_timeout="120000" allow_migrate="true"  xmfile="/etc/xen/test1"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -165,7 +165,7 @@
      <action_set>
       <rsc_op id="16" operation="migrate_from" operation_key="test2_migrate_from_0" on_node="world" on_node_uuid="e4603bf6-d10f-4af2-b53b-ba72de6164d0">
         <primitive id="test2" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_migrate_source="star" CRM_meta_migrate_target="world" CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test2"/>
+        <attributes CRM_meta_migrate_source="star" CRM_meta_migrate_target="world" CRM_meta_on_node="world" CRM_meta_on_node_uuid="e4603bf6-d10f-4af2-b53b-ba72de6164d0" CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test2"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -178,7 +178,7 @@
      <action_set>
       <rsc_op id="15" operation="migrate_to" operation_key="test2_migrate_to_0" on_node="star" on_node_uuid="3f368213-61d5-409a-a30e-1428efe70f63">
         <primitive id="test2" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_migrate_source="star" CRM_meta_migrate_target="world" CRM_meta_name="migrate_to" CRM_meta_record_pending="true" CRM_meta_timeout="120000" allow_migrate="true"  xmfile="/etc/xen/test2"/>
+        <attributes CRM_meta_migrate_source="star" CRM_meta_migrate_target="world" CRM_meta_name="migrate_to" CRM_meta_on_node="star" CRM_meta_on_node_uuid="3f368213-61d5-409a-a30e-1428efe70f63" CRM_meta_record_pending="true" CRM_meta_timeout="120000" allow_migrate="true"  xmfile="/etc/xen/test2"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -191,7 +191,7 @@
     <action_set>
       <rsc_op id="14" operation="monitor" operation_key="test2_monitor_10000" on_node="world" on_node_uuid="e4603bf6-d10f-4af2-b53b-ba72de6164d0">
         <primitive id="test2" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_start_delay="30000" CRM_meta_timeout="30000" allow_migrate="true"  xmfile="/etc/xen/test2"/>
+        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_on_node="world" CRM_meta_on_node_uuid="e4603bf6-d10f-4af2-b53b-ba72de6164d0" CRM_meta_start_delay="30000" CRM_meta_timeout="30000" allow_migrate="true"  xmfile="/etc/xen/test2"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -225,7 +225,7 @@
      <action_set>
       <rsc_op id="12" operation="stop" operation_key="test2_stop_0" on_node="star" on_node_uuid="3f368213-61d5-409a-a30e-1428efe70f63">
         <primitive id="test2" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_name="stop" CRM_meta_timeout="120000" allow_migrate="true"  xmfile="/etc/xen/test2"/>
+        <attributes CRM_meta_name="stop" CRM_meta_on_node="star" CRM_meta_on_node_uuid="3f368213-61d5-409a-a30e-1428efe70f63" CRM_meta_timeout="120000" allow_migrate="true"  xmfile="/etc/xen/test2"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -240,7 +240,7 @@
   <synapse id="17">
      <action_set>
       <crm_event id="22" operation="do_shutdown" operation_key="do_shutdown-star" on_node="star" on_node_uuid="3f368213-61d5-409a-a30e-1428efe70f63">
-        <attributes CRM_meta_op_no_wait="true" />
+        <attributes CRM_meta_on_node="star" CRM_meta_on_node_uuid="3f368213-61d5-409a-a30e-1428efe70f63" CRM_meta_op_no_wait="true" />
         <downed>
           <node id="3f368213-61d5-409a-a30e-1428efe70f63"/>
         </downed>
Index: pacemaker/pengine/test10/bug-1820.exp
===================================================================
--- pacemaker.orig/pengine/test10/bug-1820.exp
+++ pacemaker/pengine/test10/bug-1820.exp
@@ -59,7 +59,7 @@
      <action_set>
       <rsc_op id="8" operation="migrate_from" operation_key="test1_migrate_from_0" on_node="world" on_node_uuid="e4603bf6-d10f-4af2-b53b-ba72de6164d0">
         <primitive id="test1" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_migrate_source="star" CRM_meta_migrate_target="world" CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test1"/>
+        <attributes CRM_meta_migrate_source="star" CRM_meta_migrate_target="world" CRM_meta_on_node="world" CRM_meta_on_node_uuid="e4603bf6-d10f-4af2-b53b-ba72de6164d0" CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test1"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -72,7 +72,7 @@
      <action_set>
       <rsc_op id="7" operation="migrate_to" operation_key="test1_migrate_to_0" on_node="star" on_node_uuid="3f368213-61d5-409a-a30e-1428efe70f63">
         <primitive id="test1" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_migrate_source="star" CRM_meta_migrate_target="world" CRM_meta_name="migrate_to" CRM_meta_record_pending="true" CRM_meta_timeout="120000" allow_migrate="true"  xmfile="/etc/xen/test1"/>
+        <attributes CRM_meta_migrate_source="star" CRM_meta_migrate_target="world" CRM_meta_name="migrate_to" CRM_meta_on_node="star" CRM_meta_on_node_uuid="3f368213-61d5-409a-a30e-1428efe70f63" CRM_meta_record_pending="true" CRM_meta_timeout="120000" allow_migrate="true"  xmfile="/etc/xen/test1"/>
       </rsc_op>
      </action_set>
     <inputs/>
@@ -81,7 +81,7 @@
      <action_set>
       <rsc_op id="6" operation="monitor" operation_key="test1_monitor_10000" on_node="world" on_node_uuid="e4603bf6-d10f-4af2-b53b-ba72de6164d0">
         <primitive id="test1" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_start_delay="30000" CRM_meta_timeout="30000" allow_migrate="true"  xmfile="/etc/xen/test1"/>
+        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_on_node="world" CRM_meta_on_node_uuid="e4603bf6-d10f-4af2-b53b-ba72de6164d0" CRM_meta_start_delay="30000" CRM_meta_timeout="30000" allow_migrate="true"  xmfile="/etc/xen/test1"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -112,7 +112,7 @@
     <action_set>
       <rsc_op id="4" operation="stop" operation_key="test1_stop_0" on_node="star" on_node_uuid="3f368213-61d5-409a-a30e-1428efe70f63">
         <primitive id="test1" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_name="stop" CRM_meta_timeout="120000" allow_migrate="true"  xmfile="/etc/xen/test1"/>
+        <attributes CRM_meta_name="stop" CRM_meta_on_node="star" CRM_meta_on_node_uuid="3f368213-61d5-409a-a30e-1428efe70f63" CRM_meta_timeout="120000" allow_migrate="true"  xmfile="/etc/xen/test1"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -131,7 +131,7 @@
     <action_set>
       <rsc_op id="13" operation="migrate_from" operation_key="test2_migrate_from_0" on_node="world" on_node_uuid="e4603bf6-d10f-4af2-b53b-ba72de6164d0">
         <primitive id="test2" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_migrate_source="star" CRM_meta_migrate_target="world" CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test2"/>
+        <attributes CRM_meta_migrate_source="star" CRM_meta_migrate_target="world" CRM_meta_on_node="world" CRM_meta_on_node_uuid="e4603bf6-d10f-4af2-b53b-ba72de6164d0" CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test2"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -144,7 +144,7 @@
      <action_set>
       <rsc_op id="12" operation="migrate_to" operation_key="test2_migrate_to_0" on_node="star" on_node_uuid="3f368213-61d5-409a-a30e-1428efe70f63">
         <primitive id="test2" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_migrate_source="star" CRM_meta_migrate_target="world" CRM_meta_name="migrate_to" CRM_meta_record_pending="true" CRM_meta_timeout="120000" allow_migrate="true"  xmfile="/etc/xen/test2"/>
+        <attributes CRM_meta_migrate_source="star" CRM_meta_migrate_target="world" CRM_meta_name="migrate_to" CRM_meta_on_node="star" CRM_meta_on_node_uuid="3f368213-61d5-409a-a30e-1428efe70f63" CRM_meta_record_pending="true" CRM_meta_timeout="120000" allow_migrate="true"  xmfile="/etc/xen/test2"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -157,7 +157,7 @@
     <action_set>
       <rsc_op id="11" operation="monitor" operation_key="test2_monitor_10000" on_node="world" on_node_uuid="e4603bf6-d10f-4af2-b53b-ba72de6164d0">
         <primitive id="test2" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_start_delay="30000" CRM_meta_timeout="30000" allow_migrate="true"  xmfile="/etc/xen/test2"/>
+        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_on_node="world" CRM_meta_on_node_uuid="e4603bf6-d10f-4af2-b53b-ba72de6164d0" CRM_meta_start_delay="30000" CRM_meta_timeout="30000" allow_migrate="true"  xmfile="/etc/xen/test2"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -191,7 +191,7 @@
      <action_set>
       <rsc_op id="9" operation="stop" operation_key="test2_stop_0" on_node="star" on_node_uuid="3f368213-61d5-409a-a30e-1428efe70f63">
         <primitive id="test2" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_name="stop" CRM_meta_timeout="120000" allow_migrate="true"  xmfile="/etc/xen/test2"/>
+        <attributes CRM_meta_name="stop" CRM_meta_on_node="star" CRM_meta_on_node_uuid="3f368213-61d5-409a-a30e-1428efe70f63" CRM_meta_timeout="120000" allow_migrate="true"  xmfile="/etc/xen/test2"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -206,7 +206,7 @@
   <synapse id="14">
      <action_set>
       <crm_event id="19" operation="do_shutdown" operation_key="do_shutdown-star" on_node="star" on_node_uuid="3f368213-61d5-409a-a30e-1428efe70f63">
-        <attributes CRM_meta_op_no_wait="true" />
+        <attributes CRM_meta_on_node="star" CRM_meta_on_node_uuid="3f368213-61d5-409a-a30e-1428efe70f63" CRM_meta_op_no_wait="true" />
         <downed>
           <node id="3f368213-61d5-409a-a30e-1428efe70f63"/>
         </downed>
Index: pacemaker/pengine/test10/bug-1822.exp
===================================================================
--- pacemaker.orig/pengine/test10/bug-1822.exp
+++ pacemaker/pengine/test10/bug-1822.exp
@@ -60,7 +60,7 @@
      <action_set>
       <rsc_op id="14" operation="stop" operation_key="master_slave_Stateful:1_stop_0" on_node="process1a" on_node_uuid="4dbb8c56-330e-4835-a15e-c0aa632d4e89">
         <primitive id="master_slave_Stateful:1" class="ocf" provider="heartbeat" type="Dummy-statful"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="stop" CRM_meta_notify="false" CRM_meta_on_fail="stop" CRM_meta_timeout="60000"  sleep_time="10000"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="stop" CRM_meta_notify="false" CRM_meta_on_fail="stop" CRM_meta_on_node="process1a" CRM_meta_on_node_uuid="4dbb8c56-330e-4835-a15e-c0aa632d4e89" CRM_meta_timeout="60000"  sleep_time="10000"/>
       </rsc_op>
      </action_set>
      <inputs>
@@ -76,7 +76,7 @@
      <action_set>
       <rsc_op id="13" operation="demote" operation_key="master_slave_Stateful:1_demote_0" on_node="process1a" on_node_uuid="4dbb8c56-330e-4835-a15e-c0aa632d4e89">
         <primitive id="master_slave_Stateful:1" class="ocf" provider="heartbeat" type="Dummy-statful"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_timeout="120000"  sleep_time="10000"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="process1a" CRM_meta_on_node_uuid="4dbb8c56-330e-4835-a15e-c0aa632d4e89" CRM_meta_timeout="120000"  sleep_time="10000"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -89,7 +89,7 @@
      <action_set>
       <rsc_op id="16" operation="stop" operation_key="master_slave_procdctl:1_stop_0" on_node="process1a" on_node_uuid="4dbb8c56-330e-4835-a15e-c0aa632d4e89">
         <primitive id="master_slave_procdctl:1" class="ocf" provider="heartbeat" type="procdctl"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="stop" CRM_meta_notify="false" CRM_meta_on_fail="stop" CRM_meta_timeout="60000"  procd="sleep 10000"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="stop" CRM_meta_notify="false" CRM_meta_on_fail="stop" CRM_meta_on_node="process1a" CRM_meta_on_node_uuid="4dbb8c56-330e-4835-a15e-c0aa632d4e89" CRM_meta_timeout="60000"  procd="sleep 10000"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -105,7 +105,7 @@
      <action_set>
       <rsc_op id="15" operation="demote" operation_key="master_slave_procdctl:1_demote_0" on_node="process1a" on_node_uuid="4dbb8c56-330e-4835-a15e-c0aa632d4e89">
         <primitive id="master_slave_procdctl:1" class="ocf" provider="heartbeat" type="procdctl"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_timeout="120000"  procd="sleep 10000"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="process1a" CRM_meta_on_node_uuid="4dbb8c56-330e-4835-a15e-c0aa632d4e89" CRM_meta_timeout="120000"  procd="sleep 10000"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -167,7 +167,7 @@
    <synapse id="12">
      <action_set>
       <crm_event id="34" operation="do_shutdown" operation_key="do_shutdown-process1a" on_node="process1a" on_node_uuid="4dbb8c56-330e-4835-a15e-c0aa632d4e89">
-        <attributes CRM_meta_op_no_wait="true" />
+        <attributes CRM_meta_on_node="process1a" CRM_meta_on_node_uuid="4dbb8c56-330e-4835-a15e-c0aa632d4e89" CRM_meta_op_no_wait="true" />
         <downed>
           <node id="4dbb8c56-330e-4835-a15e-c0aa632d4e89"/>
         </downed>
Index: pacemaker/pengine/test10/bug-5007-masterslave_colocation.exp
===================================================================
--- pacemaker.orig/pengine/test10/bug-5007-masterslave_colocation.exp
+++ pacemaker/pengine/test10/bug-5007-masterslave_colocation.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="35" operation="start" operation_key="SLAVE_IP_start_0" on_node="fc16-builder2" on_node_uuid="fc16-builder2">
         <primitive id="SLAVE_IP" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="fc16-builder2" CRM_meta_on_node_uuid="fc16-builder2" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -16,7 +16,7 @@
     <action_set>
       <rsc_op id="34" operation="stop" operation_key="SLAVE_IP_stop_0" on_node="fc16-builder" on_node_uuid="fc16-builder">
         <primitive id="SLAVE_IP" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="fc16-builder" CRM_meta_on_node_uuid="fc16-builder" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -25,7 +25,7 @@
     <action_set>
       <rsc_op id="37" operation="start" operation_key="MASTER_IP_start_0" on_node="fc16-builder" on_node_uuid="fc16-builder">
         <primitive id="MASTER_IP" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="fc16-builder" CRM_meta_on_node_uuid="fc16-builder" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -38,7 +38,7 @@
     <action_set>
       <rsc_op id="36" operation="stop" operation_key="MASTER_IP_stop_0" on_node="fc16-builder2" on_node_uuid="fc16-builder2">
         <primitive id="MASTER_IP" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="fc16-builder2" CRM_meta_on_node_uuid="fc16-builder2" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
Index: pacemaker/pengine/test10/bug-5014-A-start-B-start.exp
===================================================================
--- pacemaker.orig/pengine/test10/bug-5014-A-start-B-start.exp
+++ pacemaker/pengine/test10/bug-5014-A-start-B-start.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="5" operation="monitor" operation_key="ClusterIP_monitor_30000" on_node="fc16-builder" on_node_uuid="fc16-builder">
         <primitive id="ClusterIP" class="ocf" provider="heartbeat" type="IPaddr2"/>
-        <attributes CRM_meta_interval="30000" CRM_meta_name="monitor" CRM_meta_timeout="20000" cidr_netmask="32"  ip="192.168.122.101"/>
+        <attributes CRM_meta_interval="30000" CRM_meta_name="monitor" CRM_meta_on_node="fc16-builder" CRM_meta_on_node_uuid="fc16-builder" CRM_meta_timeout="20000" cidr_netmask="32"  ip="192.168.122.101"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -16,7 +16,7 @@
     <action_set>
       <rsc_op id="4" operation="start" operation_key="ClusterIP_start_0" on_node="fc16-builder" on_node_uuid="fc16-builder">
         <primitive id="ClusterIP" class="ocf" provider="heartbeat" type="IPaddr2"/>
-        <attributes CRM_meta_timeout="20000" cidr_netmask="32"  ip="192.168.122.101"/>
+        <attributes CRM_meta_on_node="fc16-builder" CRM_meta_on_node_uuid="fc16-builder" CRM_meta_timeout="20000" cidr_netmask="32"  ip="192.168.122.101"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -29,7 +29,7 @@
     <action_set>
       <rsc_op id="2" operation="monitor" operation_key="ClusterIP_monitor_0" on_node="fc16-builder" on_node_uuid="fc16-builder">
         <primitive id="ClusterIP" class="ocf" provider="heartbeat" type="IPaddr2"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" cidr_netmask="32"  ip="192.168.122.101"/>
+        <attributes CRM_meta_on_node="fc16-builder" CRM_meta_on_node_uuid="fc16-builder" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" cidr_netmask="32"  ip="192.168.122.101"/>
       </rsc_op>
     </action_set>
     <inputs/>
@@ -38,7 +38,7 @@
     <action_set>
       <rsc_op id="7" operation="monitor" operation_key="ClusterIP2_monitor_30000" on_node="fc16-builder" on_node_uuid="fc16-builder">
         <primitive id="ClusterIP2" class="ocf" provider="heartbeat" type="IPaddr2"/>
-        <attributes CRM_meta_interval="30000" CRM_meta_name="monitor" CRM_meta_timeout="20000" cidr_netmask="32"  ip="192.168.122.102"/>
+        <attributes CRM_meta_interval="30000" CRM_meta_name="monitor" CRM_meta_on_node="fc16-builder" CRM_meta_on_node_uuid="fc16-builder" CRM_meta_timeout="20000" cidr_netmask="32"  ip="192.168.122.102"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -51,7 +51,7 @@
     <action_set>
       <rsc_op id="6" operation="start" operation_key="ClusterIP2_start_0" on_node="fc16-builder" on_node_uuid="fc16-builder">
         <primitive id="ClusterIP2" class="ocf" provider="heartbeat" type="IPaddr2"/>
-        <attributes CRM_meta_timeout="20000" cidr_netmask="32"  ip="192.168.122.102"/>
+        <attributes CRM_meta_on_node="fc16-builder" CRM_meta_on_node_uuid="fc16-builder" CRM_meta_timeout="20000" cidr_netmask="32"  ip="192.168.122.102"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -67,7 +67,7 @@
     <action_set>
       <rsc_op id="3" operation="monitor" operation_key="ClusterIP2_monitor_0" on_node="fc16-builder" on_node_uuid="fc16-builder">
         <primitive id="ClusterIP2" class="ocf" provider="heartbeat" type="IPaddr2"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" cidr_netmask="32"  ip="192.168.122.102"/>
+        <attributes CRM_meta_on_node="fc16-builder" CRM_meta_on_node_uuid="fc16-builder" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" cidr_netmask="32"  ip="192.168.122.102"/>
       </rsc_op>
     </action_set>
     <inputs/>
Index: pacemaker/pengine/test10/bug-5014-A-stop-B-started.exp
===================================================================
--- pacemaker.orig/pengine/test10/bug-5014-A-stop-B-started.exp
+++ pacemaker/pengine/test10/bug-5014-A-stop-B-started.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="4" operation="stop" operation_key="ClusterIP_stop_0" on_node="fc16-builder" on_node_uuid="fc16-builder">
         <primitive id="ClusterIP" class="ocf" provider="heartbeat" type="IPaddr2"/>
-        <attributes CRM_meta_timeout="20000" cidr_netmask="32"  ip="192.168.122.101"/>
+        <attributes CRM_meta_on_node="fc16-builder" CRM_meta_on_node_uuid="fc16-builder" CRM_meta_timeout="20000" cidr_netmask="32"  ip="192.168.122.101"/>
       </rsc_op>
     </action_set>
     <inputs/>
Index: pacemaker/pengine/test10/bug-5014-A-stopped-B-stopped.exp
===================================================================
--- pacemaker.orig/pengine/test10/bug-5014-A-stopped-B-stopped.exp
+++ pacemaker/pengine/test10/bug-5014-A-stopped-B-stopped.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="2" operation="monitor" operation_key="ClusterIP_monitor_0" on_node="fc16-builder" on_node_uuid="fc16-builder">
         <primitive id="ClusterIP" class="ocf" provider="heartbeat" type="IPaddr2"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" cidr_netmask="32"  ip="192.168.122.101"/>
+        <attributes CRM_meta_on_node="fc16-builder" CRM_meta_on_node_uuid="fc16-builder" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" cidr_netmask="32"  ip="192.168.122.101"/>
       </rsc_op>
     </action_set>
     <inputs/>
@@ -12,7 +12,7 @@
     <action_set>
       <rsc_op id="3" operation="monitor" operation_key="ClusterIP2_monitor_0" on_node="fc16-builder" on_node_uuid="fc16-builder">
         <primitive id="ClusterIP2" class="ocf" provider="heartbeat" type="IPaddr2"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" cidr_netmask="32"  ip="192.168.122.102"/>
+        <attributes CRM_meta_on_node="fc16-builder" CRM_meta_on_node_uuid="fc16-builder" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" cidr_netmask="32"  ip="192.168.122.102"/>
       </rsc_op>
     </action_set>
     <inputs/>
